Ice Reference Documentation
<<< Previous | Slice Documentation | Next >>>

# `Glacier2::Router`

## Overview

    interface Router
        extends
    	::Ice::Router

The Glacier2 specialization of the standard Ice router interface.

### Operation Index

`getCategoryForClient`

  This category must be used in the identities of all of the client's callback objects.

`createSession`

  Create a per-client session with the router.

`createSessionFromSecureConnection`

  Create a per-client session with the router.

`destroySession`

  Destroy the calling client's session with this router.

`getSessionTimeout`

  Get the value of the session timeout.

## `getCategoryForClient`

    string getCategoryForClient();

This category must be used in the identities of all of the client's callback objects. This is necessary in order for the router to forward callback requests to the intended client.

### Return Value

The category.

## `createSession`

    Session* createSession(string userId,
        string password)
        throws
    	PermissionDeniedException,
    	CannotCreateSessionException;

Create a per-client session with the router. If a `SessionManager` has been installed, a proxy to a `Session` object is returned to the client. Otherwise, null is returned and only an internal session (i.e., not visible to the client) is created. If a session proxy is returned, it must be configured to route through the router that created it. This will happen automatically if the router is configured as the client's default router at the time the session proxy is created in the client process, otherwise the client must configure the session proxy explicitly.

### Parameters

`userId`

  The user id for which to check the password.

`password`

  The password for the given user id.

### Return Value

A proxy for the newly created session, or null if no `SessionManager` has been installed.

### Exceptions

`PermissionDeniedException`

  Raised if the password for the given user id is not correct, or if the user is not allowed access.

`CannotCreateSessionException`

  Raised if the session cannot be created.

### See Also

`Session`, `SessionManager`, `PermissionsVerifier`

## `createSessionFromSecureConnection`

    Session* createSessionFromSecureConnection()
        throws
    	PermissionDeniedException,
    	CannotCreateSessionException;

Create a per-client session with the router. The user is authenticated through the SSL certificates that have been associated with the connection. If a `SessionManager` has been installed, a proxy to a `Session` object is returned to the client. Otherwise, null is returned and only an internal session (i.e., not visible to the client) is created. If a session proxy is returned, it must be configured to route through the router that created it. This will happen automatically if the router is configured as the client's default router at the time the session proxy is created in the client process, otherwise the client must configure the session proxy explicitly.

### Return Value

A proxy for the newly created session, or null if no `SessionManager` has been installed.

### Exceptions

`PermissionDeniedException`

  Raised if the user cannot be authenticated or if the user is not allowed access.

`CannotCreateSessionException`

  Raised if the session cannot be created.

### See Also

`Session`, `SessionManager`, `PermissionsVerifier`

## `destroySession`

    void destroySession()
        throws
    	SessionNotExistException;

Destroy the calling client's session with this router.

### Exceptions

`SessionNotExistException`

  Raised if no session exists for the calling client.

## `getSessionTimeout`

    long getSessionTimeout();

Get the value of the session timeout. Sessions are destroyed if they see no activity for this period of time.

### Return Value

The timeout (in seconds).

<<< Previous | Home | Next >>>
`Glacier2::PermissionsVerifier` | Up | `Glacier2::SSLInfo`